//
//	nMail.dll wb_
//	  Copyright (c) 1999-2007 Nanshiki corporation
//
//	  1999/ 9/ 1 Version 1.00
//	  2000/ 5/24 Version 1.08
//	  2000/11/ 1 Version 1.10
//	  2001/ 1/26 Version 1.14
//	  2004/12/28 Version 1.25
//	  2006/ 8/ 2 Version 1.28
//	  2007/ 8/ 2 Version 1.29
//

#ifndef _NMAIL_H_
#define _NMAIL_H_

#ifndef _WINSOCKAPI_
#include <winsock.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define NMAIL_ATTACHMENT_TEMP_SIZE	400

#define	NMAIL_ERROR_SOCKET			(-1)	// ڑG[
#define	NMAIL_ERROR_AUTHENTICATE	(-2)	// F؎s
#define NMAIL_ERROR_INVALID_NO		(-3)	// [ԍȂ
#define NMAIL_ERROR_TIMEOUT			(-4)	// ^CAEg
#define NMAIL_ERROR_FILE_OPEN		(-5)	// Ytt@C̃I[vs
#define NMAIL_ERROR_PARTIAL			(-6)	// t@CSĂȂ
#define NMAIL_ERROR_FILE_ALREADY	(-7)	// Ytt@Cłɑ݂
#define NMAIL_ERROR_AUTHENTICATE_NO_SUPPORT	(-8)	// FؔΉ
#define NMAIL_ERROR_MEMORY			(-9)	// ł̃mۃG[
#define NMAIL_ERROR					(-10)	// ̑̃G[
// 2004/12/28
#define NMAIL_ERROR_SUSPEND_ATTACHMENT_FILE		(-20)

#define NMAIL_ERROR_SERVICE_NOT_AVAILABLE		(-421)	// T[rXpł
#define NMAIL_ERROR_MAILBOX_UNAVAILABLE			(-450)	// [{bNXgps(gp)
#define NMAIL_ERROR_LOCAL_ERROR					(-451)	// T[o[G[
#define NMAIL_ERROR_INSUFFICIENT_SYSTEM_STORAGE	(-452)	// VXeeʕsG[
#define NMAIL_ERROR_SYNTAX_ERROR				(-500)	// R}h̕@G[
#define NMAIL_ERROR_PARAMETER					(-501)	// p[^̕@G[
#define NMAIL_ERROR_COMMAND_NOT_IMPLEMENTED		(-502)	// R}h
#define NMAIL_ERROR_BAD_SEQUENCE				(-503)	// R}h̃V[PXُ
#define NMAIL_ERROR_SMTP_AUTHENTICATE			(-535)	// SMTP F؎s
#define NMAIL_ERROR_USER_UNKOWN					(-550)	// MȂ
#define NMAIL_ERROR_USER_NOT_LOCAL				(-551)	// [U[݂ȂA]斳
#define NMAIL_ERROR_EXCEEDED_STORAGE_ALLOCATION	(-552)	// eʃI[o[G[
#define NMAIL_ERROR_MAILBOX_NAME_NOT_ALLOWED	(-553)	// [{bNXȂ
#define NMAIL_ERROR_RELAY_OPERATION_REJECTED	(-553)	// [h~G[
#define NMAIL_ERROR_TRANSACTION_FAILED			(-554)	// gUNVs

#define NMAIL_NO_ATTACHMENT_FILE	(-1)	// Ytt@CȂ
#define NMAIL_ATTACHMENT_FILE		(0)		// Ytt@C(ĂȂ)

#define NMAIL_SUCCESS				(1)		// I

// 2004/12/28
#define NMAIL_PARTIAL_ATTACHMENT_FILE	(1)		// Ytt@C擾
#define NMAIL_GET_TEXT_ONLY				(2)		// {̂ݎ擾

#define NMAIL_ADD_DATE_FIELD		(1)		// wb_DatetB[ht
#define NMAIL_ADD_MESSAGEID_FIELD	(2)		// wb_Message-IDtB[ht
// 2004/12/28
#define NMAIL_SUSPEND_ATTACHMENT_FILE	(4)		// Ytt@CMňꎞx~
#define NMAIL_SUSPEND_NEXT				(8)		// ꎞx~̓ڈȍ~
// 2007/8/2
#define NMAIL_FILE_NAME_RFC2231			(16)	// Ytt@C RFC2231 ŃGR[h
#define NMAIL_ENCODE_UTF8				(32)	// [{ UTF-8(BASE64) őM

#define NMAIL_OPTION_TIMEOUT			(0)		// ^CAEg
#define NMAIL_OPTION_HEADER_MAX			(1)		// wb_ől
#define NMAIL_OPTION_BODY_MAX			(2)		// {ől
#define NMAIL_OPTION_ALREADY_FILE		(3)		// t@C݂ꍇ̏
#define NMAIL_OPTION_DEBUG_MODE			(4)		// fobN[h
// 2003/11/4
#define NMAIL_OPTION_CONNECT_TIMEOUT	(5)		// ڑ^CAEgݒ
#define NMAIL_OPTION_SPLIT_CHAR			(6)		// ؂蕶
// 2004/12/28
#define NMAIL_OPTION_SUSPEND_SIZE		(7)		// ꎞx~t@CTCY
#define NMAIL_OPTION_SLEEP_TIME			(8)		// Sleep 
#define NMAIL_OPTION_FIELD_MAX			(9)		// wb_tB[hől

#define NMAIL_FILE_OVERWRITE		(0)		// t@C݂ꍇ㏑
#define NMAIL_FILE_RENAME			(1)		// t@C݂ꍇOύXĕۑ
#define NMAIL_FILE_ALREADY_ERROR	(2)		// t@C݂ꍇG[

#define NMAIL_GET_ERROR_MESSAGE		(0)		// G[bZ[W
#define NMAIL_GET_DEBUG_MESSAGE		(1)		// fobNbZ[W

#define NMAIL_DEBUG_START		(1)		// fobNJn
#define NMAIL_DEBUG_END			(0)		// fobNI

#define NMAIL_GET_UIDL_ALL		(0)		// SĂ UIDL 𓾂

// 2003/11/4
#define NMAIL_CONNECT_TIMEOUT_ON		(1)		// ڑ^CAEgݒON
#define NMAIL_CONNECT_TIMEOUT_OFF		(0)		// ڑ^CAEgݒOFF

// 2004/12/28
#define NMAIL_SMTP_AUTH_NOT_USE			(0)		// F؂Ȃ
#define NMAIL_SMTP_AUTH_PLAIN			(1)		// PLAIN
#define NMAIL_SMTP_AUTH_LOGIN			(2)		// LOGIN
#define NMAIL_SMTP_AUTH_CRAM_MD5		(4)		// CRAM-MD5
#define NMAIL_SMTP_AUTH_DIGEST_MD5		(8)		// DIGEST-MD5 (Ή)

//
//	o[W𓾂
//	in:  Ȃ
//	out: o[W (: 1.10 .. 110)
//
int WINAPI NMailGetVersion(VOID);

//
//	p[^ݒ
//	in:  TimeOutSec .. ^CAEg(bP)
//	     HeaderMax  .. wb_̍ől(oCg)
//	     BodyMax    .. [{̍ől(oCg)
//	out: Ȃ
//
VOID WINAPI NMailSetParameter(int TimeOutSec, int HeaderMax, int BodyMax);

//
//	WinSock 
//	in:  Ȃ
//	out: TRUE .. 
//
BOOL WINAPI NMailInitializeWinSock(VOID);

//
//	WinSock I
//	in:  Ȃ
//	out: TRUE .. I
//
BOOL WINAPI NMailEndWinSock(VOID);

//
//	POP3 T[oɐڑ
//	in:  HostName .. POP3 zXg
//	out: \Pbg
//	     INVALID_SOCKET ŃG[
//
SOCKET WINAPI NMailPop3Connect(LPCTSTR HostName);
SOCKET WINAPI NMailPop3ConnectA(LPCSTR HostName);
SOCKET WINAPI NMailPop3ConnectW(LPCWSTR HostName);
#if _MBCS
#define NMailPop3Connect	NMailPop3ConnectA
#endif
#ifdef _UNICODE
#define NMailPop3Connect	NMailPop3ConnectW
#endif

//
//	POP3 T[oɐڑ(|[gԍw)
//	in:  HostName .. POP3 zXg
//       PortNo   .. |[gԍ
//	out: \Pbg
//
SOCKET WINAPI NMailPop3ConnectPortNo(LPCTSTR HostName, int PortNo);
SOCKET WINAPI NMailPop3ConnectPortNoA(LPCSTR HostName, int PortNo);
SOCKET WINAPI NMailPop3ConnectPortNoW(LPCWSTR HostName, int PortNo);
#ifdef _MBCS
#define NMailPop3ConnectPortNo	NMailPop3ConnectPortNoA
#endif
#ifdef _UNICODE
#define NMailPop3ConnectPortNo	NMailPop3ConnectPortNoW
#endif

//
//	POP3 F
//	in:  Socket   .. \Pbg
//	     Id       .. [U[
//	     Password .. pX[h
//	     APopFlag .. APOP gp邩(True Ŏgp)
//	out: [
//	     ̐ŃG[
//
int WINAPI NMailPop3Authenticate(SOCKET Socket, LPCTSTR Id, LPCTSTR Password, BOOL APopFlag);
int WINAPI NMailPop3AuthenticateA(SOCKET Socket, LPCSTR Id, LPCSTR Password, BOOL APopFlag);
int WINAPI NMailPop3AuthenticateW(SOCKET Socket, LPCWSTR Id, LPCWSTR Password, BOOL APopFlag);
#ifdef _MBCS
#define NMailPop3Authenticate	NMailPop3AuthenticateA
#endif
#ifdef _UNICODE
#define NMailPop3Authenticate	NMailPop3AuthenticateW
#endif

//
//	POP3 ڑI
//	in:  Socket   .. \Pbg
//	out: ̐ŃG[
//
int WINAPI NMailPop3Close(SOCKET Socket);

//
//	POP3 [̏𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     SizeFlag .. TRUE ȂTCYԂ
//	out: SizeFlag  TRUE ȂTCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMailStatus(SOCKET Socket, int No, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, BOOL SizeFlag);
int WINAPI NMailPop3GetMailStatusA(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, BOOL SizeFlag);
int WINAPI NMailPop3GetMailStatusW(SOCKET Socket, int No, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, BOOL SizeFlag);
#ifdef _MBCS
#define NMailPop3GetMailStatus	NMailPop3GetMailStatusA
#endif
#ifdef _UNICODE
#define NMailPop3GetMailStatus	NMailPop3GetMailStatusW
#endif

//
//	POP3 [̃TCY𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	out: [̃TCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMailSize(SOCKET Socket, int No);

//
//	POP3 [𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     Header   .. [̃wb_
//	     Body     .. [̖{
//	     Path     .. Ytt@CۑfBNg
//	                 NULL ŕۑ
//	     FileName .. Ytt@Ci[obt@
//	                 NULL Ŋi[
//	out: [̃TCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMail(SOCKET Socket, int No, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, LPTSTR Body, LPCTSTR Path, LPTSTR FileName);
int WINAPI NMailPop3GetMailA(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName);
int WINAPI NMailPop3GetMailW(SOCKET Socket, int No, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, LPWSTR Body, LPCWSTR Path, LPWSTR FileName);
#ifdef _MBCS
#define NMailPop3GetMail	NMailPop3GetMailA
#endif
#ifdef _UNICODE
#define NMailPop3GetMail	NMailPop3GetMailW
#endif

//
//	POP3 [𓾂(Ytt@CΉ)
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     Header   .. [̃wb_
//	     Body     .. [̖{
//	     Path     .. Ytt@CۑfBNg
//	     FileName .. Ytt@Ci[obt@
//	out: ̐ŃG[
//
int WINAPI NMailPop3GetMailPartial(SOCKET Socket, int No, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, LPTSTR Body, LPCTSTR Path, LPTSTR FileName);
int WINAPI NMailPop3GetMailPartialA(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName);
int WINAPI NMailPop3GetMailPartialW(SOCKET Socket, int No, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, LPWSTR Body, LPCWSTR Path, LPWSTR FileName);
#ifdef _MBCS
#define NMailPop3GetMailPartial	NMailPop3GetMailPartialA
#endif
#ifdef _UNICODE
#define NMailPop3GetMailPartial	NMailPop3GetMailPartialW
#endif

//
//	POP3 [𓾂 IvVt ꎞx~
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     Header   .. [̃wb_
//	     Body     .. [̖{
//	     Path     .. Ytt@CۑfBNg
//	                 NULL ŕۑ
//	     FileName .. Ytt@Ci[obt@
//	                 NULL Ŋi[
//	     Temp     .. ꎞƃGA
//	                 NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                 NULL  nMail.DLL ̃obt@gp
//	     Flag     .. tO
//	out: [̃TCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMailEx(SOCKET Socket, int No, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, LPTSTR Body, LPCTSTR Path, LPTSTR FileName, LPTSTR Temp, int Flag);
int WINAPI NMailPop3GetMailExA(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName, LPSTR Temp, int Flag);
int WINAPI NMailPop3GetMailExW(SOCKET Socket, int No, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, LPWSTR Body, LPCWSTR Path, LPWSTR FileName, LPSTR Temp, int Flag);
#ifdef _MBCS
#define NMailPop3GetMailEx	NMailPop3GetMailExA
#endif
#ifdef _UNICODE
#define NMailPop3GetMailEx	NMailPop3GetMailExW
#endif

//
//	POP3 [폜
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	out: ̐ŃG[
//
int WINAPI NMailPop3DeleteMail(SOCKET Socket, int No);

//
//	POP3 [Ytt@Ct`FbN
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Id       .. t@C ID i[obt@
//	     Max      .. obt@TCY
//	out: NMAIL_NO_ATTACHMENT_FILE    .. Ytt@CȂ
//	     NMAIL_ATTACHMENT_FILE ȏ  .. Ytt@C
//	                                    NMAIL_ATTACHMENT_FILE(0) ŕ
//	                                    ĂȂYtt@C
//	                                    1 ȏ̏ꍇĂYt
//	                                    t@CŐl̓p[gԍ
//
int WINAPI NMailPop3GetAttachmentFileStatus(SOCKET Socket, int No, LPTSTR Id, int Max);
int WINAPI NMailPop3GetAttachmentFileStatusA(SOCKET Socket, int No, LPSTR Id, int Max);
int WINAPI NMailPop3GetAttachmentFileStatusW(SOCKET Socket, int No, LPWSTR Id, int Max);
#ifdef _MBCS
#define NMailPop3GetAttachmentFileStatus	NMailPop3GetAttachmentFileStatusA
#endif
#ifdef _UNICODE
#define NMailPop3GetAttachmentFileStatus	NMailPop3GetAttachmentFileStatusW
#endif

//
//	UIDL 𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Uidl     .. UIDL i[obt@
//	     Max      .. obt@TCY
//	out: ̐ŃG[
//
int WINAPI NMailPop3GetUidl(SOCKET Socket, int No, LPTSTR Uidl, int Max);
int WINAPI NMailPop3GetUidlA(SOCKET Socket, int No, LPSTR Uidl, int Max);
int WINAPI NMailPop3GetUidlW(SOCKET Socket, int No, LPWSTR Uidl, int Max);
#ifdef _MBCS
#define NMailPop3GetUidl	NMailPop3GetUidlA
#endif
#ifdef _UNICODE
#define NMailPop3GetUidl	NMailPop3GetUidlW
#endif

//
//	[𑗐M
//	in:  HostName .. SMTP T[o
//	     To       .. 
//	     Cc       .. CC
//	     Bcc      .. BCC
//	     From     .. ol
//	     Subject  .. 薼
//	     Body     .. [{
//	     Header   .. ̃wb_
//	     Path     .. Ytt@C(ȂNULL)
//	     Flag     .. wb_Date/Message-IDt邩
//	out: ̐ŃG[
//
int WINAPI NMailSmtpSendMail(LPCTSTR HostName, LPCTSTR To, LPCTSTR Cc, LPCTSTR Bcc, LPCTSTR From, LPCTSTR Subject, LPCTSTR Body, LPCTSTR Header, LPCTSTR Path, int Flag);
int WINAPI NMailSmtpSendMailA(LPCSTR HostName, LPCSTR To, LPCSTR Cc, LPCSTR Bcc, LPCSTR From, LPCSTR Subject, LPCSTR Body, LPCSTR Header, LPCSTR Path, int Flag);
int WINAPI NMailSmtpSendMailW(LPCWSTR HostName, LPCWSTR To, LPCWSTR Cc, LPCWSTR Bcc, LPCWSTR From, LPCWSTR Subject, LPCWSTR Body, LPCWSTR Header, LPCWSTR Path, int Flag);
#ifdef _MBCS
#define NMailSmtpSendMail	NMailSmtpSendMailA
#endif
#ifdef _UNICODE
#define NMailSmtpSendMail	NMailSmtpSendMailW
#endif

//
//	[𑗐M
//	in:  HostName .. SMTP T[o
//	     To       .. 
//	     Cc       .. CC
//	     Bcc      .. BCC
//	     From     .. ol
//	     Subject  .. 薼
//	     Body     .. [{
//	     Header   .. ̃wb_
//	     Path     .. Ytt@C(ȂNULL)
//	     Flag     .. wb_Date/Message-IDt邩
//	     PortNo   .. SMTP |[gԍ
//	out: ̐ŃG[
//
int WINAPI NMailSmtpSendMailPortNo(LPCTSTR HostName, LPCTSTR To, LPCTSTR Cc, LPCTSTR Bcc, LPCTSTR From, LPCTSTR Subject, LPCTSTR Body, LPCTSTR Header, LPCTSTR Path, int Flag, int PortNo);
int WINAPI NMailSmtpSendMailPortNoA(LPCSTR HostName, LPCSTR To, LPCSTR Cc, LPCSTR Bcc, LPCSTR From, LPCSTR Subject, LPCSTR Body, LPCSTR Header, LPCSTR Path, int Flag, int PortNo);
int WINAPI NMailSmtpSendMailPortNoW(LPCWSTR HostName, LPCWSTR To, LPCWSTR Cc, LPCWSTR Bcc, LPCWSTR From, LPCWSTR Subject, LPCWSTR Body, LPCWSTR Header, LPCWSTR Path, int Flag, int PortNo);
#ifdef _MBCS
#define NMailSmtpSendMailPortNo	NMailSmtpSendMailPortNoA
#endif
#ifdef _UNICODE
#define NMailSmtpSendMailPortNo	NMailSmtpSendMailPortNoW
#endif

// Version 1.25
//
//	SMTP T[oɐڑ
//	in:  HostName .. SMTP zXg
//	out: \Pbg
//	     INVALID_SOCKET ŃG[
//
SOCKET WINAPI NMailSmtpConnect(LPCTSTR HostName);
SOCKET WINAPI NMailSmtpConnectA(LPCSTR HostName);
SOCKET WINAPI NMailSmtpConnectW(LPCWSTR HostName);
#ifdef _MBCS
#define NMailSmtpConnect	NMailSmtpConnectA
#endif
#ifdef _UNICODE
#define NMailSmtpConnect	NMailSmtpConnectW
#endif

//
//	SMTP T[oɐڑ(|[gԍw)
//	in:  HostName .. SMTP zXg
//       PortNo   .. |[gԍ
//	out: \Pbg
//
SOCKET WINAPI NMailSmtpConnectPortNo(LPCTSTR HostName, int PortNo);
SOCKET WINAPI NMailSmtpConnectPortNoA(LPCSTR HostName, int PortNo);
SOCKET WINAPI NMailSmtpConnectPortNoW(LPCWSTR HostName, int PortNo);
#ifdef _MBCS
#define NMailSmtpConnectPortNo	NMailSmtpConnectPortNoA
#endif
#ifdef _UNICODE
#define NMailSmtpConnectPortNo	NMailSmtpConnectPortNoW
#endif

//
//	SMTP F
//	in:  Socket   .. \Pbg
//	     HostName .. SMTP zXg
//	     Id       .. [U[
//	     Password .. pX[h
//	     Mode     .. AUTH 
//	out: ̐ŃG[
//
int WINAPI NMailSmtpAuthenticate(SOCKET Socket, LPCTSTR HostName, LPCTSTR Id, LPCTSTR Password, int Mode);
int WINAPI NMailSmtpAuthenticateA(SOCKET Socket, LPCSTR HostName, LPCSTR Id, LPCSTR Password, int Mode);
int WINAPI NMailSmtpAuthenticateW(SOCKET Socket, LPCWSTR HostName, LPCWSTR Id, LPCWSTR Password, int Mode);
#ifdef _MBCS
#define NMailSmtpAuthenticate	NMailSmtpAuthenticateA
#endif
#ifdef _UNICODE
#define NMailSmtpAuthenticate	NMailSmtpAuthenticateW
#endif

//
//	[𑗐M \Pbgw
//	in:  Socket   .. \Pbg
//	     To       .. 
//	     Cc       .. CC
//	     Bcc      .. BCC
//	     From     .. ol
//	     Subject  .. 薼
//	     Body     .. [{
//	     Header   .. ̃wb_
//	     Path     .. Ytt@C(ȂNULL)
//	     Temp     .. ꎞƃGA
//	                 NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                 NULL  nMail.DLL ̃obt@gp
//	     Flag     .. etO
//	out: ̐ŃG[
//	      Flag  NMAIL_SUSPEND_ATTACHMENT_FILE w肵ꍇ
//	     NMAIL_ERROR_SUSPEND_ATTACHMENT_FILE AĂꍇ͑M
//	     ꎞx~Ŗ߂ĂƂɂȂ
//
int WINAPI NMailSmtpSendMailEx(SOCKET Socket, LPCTSTR To, LPCTSTR Cc, LPCTSTR Bcc, LPCTSTR From, LPCTSTR Subject, LPCTSTR Body, LPCTSTR Header, LPCTSTR Path, LPTSTR Temp, int Flag);
int WINAPI NMailSmtpSendMailExA(SOCKET Socket, LPCSTR To, LPCSTR Cc, LPCSTR Bcc, LPCSTR From, LPCSTR Subject, LPCSTR Body, LPCSTR Header, LPCSTR Path, LPSTR Temp, int Flag);
int WINAPI NMailSmtpSendMailExW(SOCKET Socket, LPCWSTR To, LPCWSTR Cc, LPCWSTR Bcc, LPCWSTR From, LPCWSTR Subject, LPCWSTR Body, LPCWSTR Header, LPCWSTR Path, LPSTR Temp, int Flag);
#ifdef _MBCS
#define NMailSmtpSendMailEx	NMailSmtpSendMailExA
#endif
#ifdef _UNICODE
#define NMailSmtpSendMailEx	NMailSmtpSendMailExW
#endif

//
//	SMTP ڑI
//	in:  Socket   .. \Pbg
//	out: ̐ŃG[
//
int WINAPI NMailSmtpClose(SOCKET Socket);

//
//	wb_i[Ăobt@珊̃tB[ho
//	in:  Field    .. tB[hli[obt@
//	     Header   .. wb_i[Ăobt@
//	     Name     .. tB[h
//	     Size     .. i[obt@̃TCY
//	out: TRUE     .. tB[h
//
BOOL WINAPI NMailGetHeaderField(LPTSTR Field, LPCTSTR Header, LPCTSTR Name, int Size);
BOOL WINAPI NMailGetHeaderFieldA(LPSTR Field, LPCSTR Header, LPCSTR Name, int Size);
BOOL WINAPI NMailGetHeaderFieldW(LPWSTR Field, LPCWSTR Header, LPCWSTR Name, int Size);
#ifdef _MBCS
#define NMailGetHeaderField	NMailGetHeaderFieldA
#endif
#ifdef _UNICODE
#define NMailGetHeaderField	NMailGetHeaderFieldW
#endif

//
//	t@CJn
//	in:  Temp        .. ꎞƃGA
//	                    NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                    NULL  nMail.DLL ̃obt@gp
//	     Subject     .. [̑薼
//	     Date        .. [̑M
//	     From        .. [̍ol
//	     Header      .. WJ̃wb_i[obt@
//	     Body        .. WJ̖{i[obt@
//	     Path        .. Ytt@CۑfBNg
//	     FileName    .. Ytt@Ci[obt@
//	     FirstHeader .. ŏ̃[wb_
//	     FirstBody   .. ŏ̃[{
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileFirst(LPSTR Temp, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, LPTSTR Body, LPCTSTR Path, LPTSTR FileName, LPCTSTR FirstHeader, LPCTSTR FirstBody);
int WINAPI NMailAttachmentFileFirstA(LPSTR Temp, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName, LPCSTR FirstHeader, LPCSTR FirstBody);
int WINAPI NMailAttachmentFileFirstW(LPSTR Temp, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, LPWSTR Body, LPCWSTR Path, LPWSTR FileName, LPCWSTR FirstHeader, LPCWSTR FirstBody);
#ifdef _MBCS
#define NMailAttachmentFileFirst	NMailAttachmentFileFirstA
#endif
#ifdef _UNICODE
#define NMailAttachmentFileFirst	NMailAttachmentFileFirstW
#endif

//
//	t@C
//	in:  Temp       .. ꎞƃGA
//	                   NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                   NULL  nMail.DLL ̃obt@gp
//	     NextHeader .. Qڈȍ~̃[wb_
//	     NextBody   .. Qڈȍ~̃[{
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileNext(LPSTR Temp, LPCTSTR NextHeader, LPCTSTR NextBody);
int WINAPI NMailAttachmentFileNextA(LPSTR Temp, LPCSTR NextHeader, LPCSTR NextBody);
int WINAPI NMailAttachmentFileNextW(LPSTR Temp, LPCWSTR NextHeader, LPCWSTR NextBody);
#ifdef _MBCS
#define NMailAttachmentFileNext	NMailAttachmentFileNextA
#endif
#ifdef _UNICODE
#define NMailAttachmentFileNext	NMailAttachmentFileNextW
#endif

//
//	t@C(VisualBasic p)
//
int WINAPI NMailAttachmentFileNextVB(LPSTR Temp, LPTSTR Subject, LPTSTR Date, LPTSTR From, LPTSTR Header, LPTSTR Body, LPCTSTR Path, LPTSTR FileName, LPCTSTR NextHeader, LPCTSTR NextBody);
int WINAPI NMailAttachmentFileNextVBA(LPSTR Temp, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName, LPCSTR NextHeader, LPCSTR NextBody);
int WINAPI NMailAttachmentFileNextVBW(LPSTR Temp, LPWSTR Subject, LPWSTR Date, LPWSTR From, LPWSTR Header, LPWSTR Body, LPCWSTR Path, LPWSTR FileName, LPCWSTR NextHeader, LPCWSTR NextBody);
#ifdef _MBCS
#define NMailAttachmentFileNextVB	NMailAttachmentFileNextVBA
#endif
#ifdef _UNICODE
#define NMailAttachmentFileNextVB	NMailAttachmentFileNextVBW
#endif

//
//	t@CI
//	in:  Temp     .. ꎞƃGA
//	                 NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileClose(LPSTR Temp);

//
//	t@C̏𓾂
//	in:  Header   .. wb_i[Ăobt@
//	     Id       .. t@C ID i[obt@
//	     Max      .. obt@TCY
//	out: NMAIL_NO_ATTACHMENT_FILE    .. Ytt@CȂ
//	     NMAIL_ATTACHMENT_FILE ȏ  .. Ytt@C
//	                                    NMAIL_ATTACHMENT_FILE(0) ŕ
//	                                    ĂȂYtt@C
//	                                    1 ȏ̏ꍇĂYt
//	                                    t@CŐl̓p[gԍ
//
int WINAPI NMailAttachmentFileStatus(LPCTSTR Header, LPTSTR Id, int Max);
int WINAPI NMailAttachmentFileStatusA(LPCSTR Header, LPSTR Id, int Max);
int WINAPI NMailAttachmentFileStatusW(LPCWSTR Header, LPWSTR Id, int Max);
#ifdef _MBCS
#define NMailAttachmentFileStatus	NMailAttachmentFileStatusA
#endif
#ifdef _UNICODE
#define NMailAttachmentFileStatus	NMailAttachmentFileStatusW
#endif

//
//	IvVݒ
//	in:  Option  .. IvV
//	     Value   .. IvV̒l
//
BOOL WINAPI NMailSetOption(int Option, int Value);

//
//	IvVl̎擾
//	in:  Option  .. IvV
//  out: IvV̒l
//
int WINAPI NMailGetOption(int Option);

//
//	G[bZ[W𓾂
//	in:  Mtype    .. bZ[W
//		 Message  .. bZ[Wi[obt@
//	     Size     .. obt@TCY
//
VOID WINAPI NMailGetMessage(int Mtype, LPTSTR Message, int Size);
VOID WINAPI NMailGetMessageA(int Mtype, LPSTR Message, int Size);
VOID WINAPI NMailGetMessageW(int Mtype, LPWSTR Message, int Size);
#ifdef _MBCS
#define NMailGetMessage	NMailGetMessageA
#endif
#ifdef _UNICODE
#define NMailGetMessage	NMailGetMessageW
#endif

//
//	݂̒Pʂł̋x~񐔂Zo
//	in:  Path .. Ytt@C
//	out: x~
//	     NMAIL_ERROR_FILE_OPEN .. t@C݂Ȃ
//
int WINAPI NMailGetSuspendNumber(LPCTSTR Path);
int WINAPI NMailGetSuspendNumberA(LPCSTR Path);
int WINAPI NMailGetSuspendNumberW(LPCWSTR Path);
#ifdef _MBCS
#define NMailGetSuspendNumber	NMailGetSuspendNumberA
#endif
#ifdef _UNICODE
#define NMailGetSuspendNumber	NMailGetSuspendNumberW
#endif

#ifdef __cplusplus
}
#endif

#endif
